import 'dart:async';

import 'package:shared_preferences/shared_preferences.dart';

const String _storageKey = "ServiceCountry_";

Future<SharedPreferences> _prefs = SharedPreferences.getInstance();

ServiceCountryPreferences serviceCountryPreferences =
    ServiceCountryPreferences();

class ServiceCountryPreferences {
  /// ----------------------------------------------------------
  /// Generic routine to fetch a preference
  /// ----------------------------------------------------------
  Future<String> _getStringApplicationSavedInformation(String name) async {
    final SharedPreferences prefs = await _prefs;

    return prefs.getString(_storageKey + name) ?? '';
  }

  Future<bool> _setStringApplicationSavedInformation(
      String name, String value) async {
    final SharedPreferences prefs = await _prefs;

    return prefs.setString(_storageKey + name, value);
  }

  Future<String> getPreferredServiceCountryAPIURL() async {
    return _getStringApplicationSavedInformation('api');
  }

  Future<String> getPreferredServiceCountry() async {
    return _getStringApplicationSavedInformation('countryCode');
  }

  Future<bool> setPreferredServiceCountryAPIURL(String api) async {
    return _setStringApplicationSavedInformation('api', api);
  }

  Future<bool> setPreferredServiceCountry(String countryCode) async {
    return _setStringApplicationSavedInformation('countryCode', countryCode);
  }

  // ------------------ SINGLETON -----------------------
  static final ServiceCountryPreferences _preferences =
      ServiceCountryPreferences._internal();

  factory ServiceCountryPreferences() {
    return _preferences;
  }

  ServiceCountryPreferences._internal();
}
