import 'package:hqsoft_core/core_base/core_base.dart';
import 'package:hqsoft_core/data_base/data_base.dart';
import 'package:hqsoft_core/data_base/model_body_request/body_request_token_connect_model.dart';

class BodyRequestGeneralBase {
  static Future<BodyRequestLogin> createBodyRequestLogin(
      String countryCode, String userName, String password) async {
    List<String> scopes = ["identity", "openid", "profile", "app", "api"];
    BodyRequestLogin bodyRequestLogin = new BodyRequestLogin();
    bodyRequestLogin.identity = countryCode + userName;
    bodyRequestLogin.password = password;
    bodyRequestLogin.scopes = scopes;
    bodyRequestLogin.clientId = "";
    bodyRequestLogin.imei = await deviceIdPreferences.getPreferredDeviceID();
    bodyRequestLogin.tokenFCM =
        await tokenFireBaseReferences.getPreferredTokenFCM();
//    bodyRequestLogin.localTime = DateHelper.getStringJson(DateTime.now());
    return bodyRequestLogin;
  }

  static Future<BodyRequestCreateUserAppToken>
      createBodyRequestCreateUserAppToken(
          String userId, String appId, String token) async {
    BodyRequestCreateUserAppToken bodyRequestCreateUserAppToken =
        new BodyRequestCreateUserAppToken();
    bodyRequestCreateUserAppToken.userId = userId;
    bodyRequestCreateUserAppToken.appId = appId;
    bodyRequestCreateUserAppToken.token = token;

    return bodyRequestCreateUserAppToken;
  }

  static Future<BodyRequestConnect> createBodyConnectToken(
      String countryCode, String userName, String password) async {
    List<String> scopes = ["openid", "profile", "offline_access", "api"];
    BodyRequestConnect bodyRequestLogin = new BodyRequestConnect();
    bodyRequestLogin.username = countryCode + userName;
    bodyRequestLogin.password = password;
    bodyRequestLogin.scopes = scopes;
    bodyRequestLogin.clientId = "ro.client";
    bodyRequestLogin.grant_type = "password";
    bodyRequestLogin.client_secret = "secret";
    return bodyRequestLogin;
  }
}
